diff --git a/src/backend/optimizer/plan/planner.c b/src/backend/optimizer/plan/planner.c
new file mode 100644
index 649a233..d47f635
*** a/src/backend/optimizer/plan/planner.c
--- b/src/backend/optimizer/plan/planner.c
*************** get_partitioned_child_rels(PlannerInfo *
*** 6083,6085 ****
--- 6200,6230 ----
  
  	return result;
  }
+ 
+ /*
+  * get_partitioned_child_rels_for_join
+  *		Build and return a list containing the RTI of every partitioned
+  *		relation which is a child of some rel included in the join.
+  *
+  * Note: Only call this function on joins between partitioned tables.
+  */
+ List *
+ get_partitioned_child_rels_for_join(PlannerInfo *root,
+ 									RelOptInfo *joinrel)
+ {
+ 	List	   *result = NIL;
+ 	ListCell   *l;
+ 
+ 	foreach(l, root->pcinfo_list)
+ 	{
+ 		PartitionedChildRelInfo	*pc = lfirst(l);
+ 
+ 		if (bms_is_member(pc->parent_relid, joinrel->relids))
+ 			result = list_concat(result, list_copy(pc->child_rels));
+ 	}
+ 
+ 	/* The root partitioned table is included as a child rel */
+ 	Assert(list_length(result) >= bms_num_members(joinrel->relids));
+ 
+ 	return result;
+ }
diff --git a/src/backend/optimizer/plan/setrefs.c b/src/backend/optimizer/plan/setrefs.c
new file mode 100644
index 1278371..44c3919
*** a/src/backend/optimizer/plan/setrefs.c
--- b/src/backend/optimizer/plan/setrefs.c
*************** typedef struct
*** 40,46 ****
--- 40,50 ----
  	List	   *tlist;			/* underlying target list */
  	int			num_vars;		/* number of plain Var tlist entries */
  	bool		has_ph_vars;	/* are there PlaceHolderVar entries? */
+ 	bool		has_grp_vars;	/* are there GroupedVar entries? */
  	bool		has_non_vars;	/* are there other entries? */
+ 	bool		has_conv_whole_rows;	/* are there ConvertRowtypeExpr entries
+ 										 * encapsulating a whole-row Var?
+ 										 */
  	tlist_vinfo vars[FLEXIBLE_ARRAY_MEMBER];	/* has num_vars entries */
  } indexed_tlist;
  
*************** static List *set_returning_clause_refere
*** 139,144 ****
--- 143,149 ----
  								int rtoffset);
  static bool extract_query_dependencies_walker(Node *node,
  								  PlannerInfo *context);
+ static Var *get_wholerow_ref_from_convert_row_type(Node *node);
  
  /*****************************************************************************
   *
*************** set_upper_references(PlannerInfo *root,
*** 1725,1733 ****
--- 1730,1781 ----
  	indexed_tlist *subplan_itlist;
  	List	   *output_targetlist;
  	ListCell   *l;
+ 	List	*sub_tlist_save = NIL;
+ 
+ 	if (root->grouped_var_list != NIL)
+ 	{
+ 		if (IsA(plan, Agg))
+ 		{
+ 			Agg	*agg = (Agg *) plan;
+ 
+ 			if (agg->aggsplit == AGGSPLIT_FINAL_DESERIAL)
+ 			{
+ 				/*
+ 				 * convert_combining_aggrefs could have replaced some vars
+ 				 * with Aggref expressions representing the partial
+ 				 * aggregation. We need to restore the same Aggrefs in the
+ 				 * subplan targetlist, but this would break the subplan if
+ 				 * it's something else than the partial aggregation (i.e. the
+ 				 * partial aggregation takes place lower in the plan tree). So
+ 				 * we'll eventually need to restore the original list.
+ 				 */
+ 				if (!IsA(subplan, Agg))
+ 					sub_tlist_save = subplan->targetlist;
+ #ifdef USE_ASSERT_CHECKING
+ 				else
+ 					Assert(((Agg *) subplan)->aggsplit == AGGSPLIT_INITIAL_SERIAL);
+ #endif	/* USE_ASSERT_CHECKING */
+ 
+ 				/*
+ 				 * Restore the aggregate expressions that we might have
+ 				 * removed when planning for aggregation at base relation
+ 				 * level.
+ 				 */
+ 				subplan->targetlist =
+ 					restore_grouping_expressions(root, subplan->targetlist);
+ 			}
+ 		}
+ 	}
  
  	subplan_itlist = build_tlist_index(subplan->targetlist);
  
+ 	/*
+ 	 * The replacement of GroupVars by Aggrefs was only needed for the index
+ 	 * build.
+ 	 */
+ 	if (sub_tlist_save != NIL)
+ 		subplan->targetlist = sub_tlist_save;
+ 
  	output_targetlist = NIL;
  	foreach(l, plan->targetlist)
  	{
*************** build_tlist_index(List *tlist)
*** 1937,1943 ****
--- 1985,1993 ----
  
  	itlist->tlist = tlist;
  	itlist->has_ph_vars = false;
+ 	itlist->has_grp_vars = false;
  	itlist->has_non_vars = false;
+ 	itlist->has_conv_whole_rows = false;
  
  	/* Find the Vars and fill in the index array */
  	vinfo = itlist->vars;
*************** build_tlist_index(List *tlist)
*** 1956,1961 ****
--- 2006,2015 ----
  		}
  		else if (tle->expr && IsA(tle->expr, PlaceHolderVar))
  			itlist->has_ph_vars = true;
+ 		else if (tle->expr && IsA(tle->expr, GroupedVar))
+ 			itlist->has_grp_vars = true;
+ 		else if (get_wholerow_ref_from_convert_row_type((Node *) tle->expr))
+ 			itlist->has_conv_whole_rows = true;
  		else
  			itlist->has_non_vars = true;
  	}
*************** build_tlist_index(List *tlist)
*** 1971,1977 ****
   * This is like build_tlist_index, but we only index tlist entries that
   * are Vars belonging to some rel other than the one specified.  We will set
   * has_ph_vars (allowing PlaceHolderVars to be matched), but not has_non_vars
!  * (so nothing other than Vars and PlaceHolderVars can be matched).
   */
  static indexed_tlist *
  build_tlist_index_other_vars(List *tlist, Index ignore_rel)
--- 2025,2034 ----
   * This is like build_tlist_index, but we only index tlist entries that
   * are Vars belonging to some rel other than the one specified.  We will set
   * has_ph_vars (allowing PlaceHolderVars to be matched), but not has_non_vars
!  * (so nothing other than Vars and PlaceHolderVars can be matched). In case of
!  * DML, where this function will be used, returning lists from child relations
!  * will be appended similar to a simple append relation. That does not require
!  * fixing ConvertRowtypeExpr references. So, those are not considered here.
   */
  static indexed_tlist *
  build_tlist_index_other_vars(List *tlist, Index ignore_rel)
*************** build_tlist_index_other_vars(List *tlist
*** 1988,1993 ****
--- 2045,2051 ----
  	itlist->tlist = tlist;
  	itlist->has_ph_vars = false;
  	itlist->has_non_vars = false;
+ 	itlist->has_conv_whole_rows = false;
  
  	/* Find the desired Vars and fill in the index array */
  	vinfo = itlist->vars;
*************** fix_join_expr_mutator(Node *node, fix_jo
*** 2233,2238 ****
--- 2291,2321 ----
  		/* No referent found for Var */
  		elog(ERROR, "variable not found in subplan target lists");
  	}
+ 	if (IsA(node, GroupedVar))
+ 	{
+ 		GroupedVar *gvar = (GroupedVar *) node;
+ 
+ 		/* See if the GroupedVar has bubbled up from a lower plan node */
+ 		if (context->outer_itlist && context->outer_itlist->has_grp_vars)
+ 		{
+ 			newvar = search_indexed_tlist_for_non_var((Expr *) gvar,
+ 													  context->outer_itlist,
+ 													  OUTER_VAR);
+ 			if (newvar)
+ 				return (Node *) newvar;
+ 		}
+ 		if (context->inner_itlist && context->inner_itlist->has_grp_vars)
+ 		{
+ 			newvar = search_indexed_tlist_for_non_var((Expr *) gvar,
+ 													  context->inner_itlist,
+ 													  INNER_VAR);
+ 			if (newvar)
+ 				return (Node *) newvar;
+ 		}
+ 
+ 		/* No referent found for GroupedVar */
+ 		elog(ERROR, "grouped variable not found in subplan target lists");
+ 	}
  	if (IsA(node, PlaceHolderVar))
  	{
  		PlaceHolderVar *phv = (PlaceHolderVar *) node;
*************** fix_join_expr_mutator(Node *node, fix_jo
*** 2258,2263 ****
--- 2341,2369 ----
  		/* If not supplied by input plans, evaluate the contained expr */
  		return fix_join_expr_mutator((Node *) phv->phexpr, context);
  	}
+ 	if (get_wholerow_ref_from_convert_row_type(node))
+ 	{
+ 		if (context->outer_itlist &&
+ 			context->outer_itlist->has_conv_whole_rows)
+ 		{
+ 			newvar = search_indexed_tlist_for_non_var((Expr *) node,
+ 													 context->outer_itlist,
+ 																OUTER_VAR);
+ 
+ 			if (newvar)
+ 				return (Node *) newvar;
+ 		}
+ 		if (context->inner_itlist &&
+ 			context->inner_itlist->has_conv_whole_rows)
+ 		{
+ 			newvar = search_indexed_tlist_for_non_var((Expr *) node,
+ 													 context->inner_itlist,
+ 																INNER_VAR);
+ 
+ 			if (newvar)
+ 				return (Node *) newvar;
+ 		}
+ 	}
  	if (IsA(node, Param))
  		return fix_param_node(context->root, (Param *) node);
  	/* Try matching more complex expressions too, if tlists have any */
*************** fix_upper_expr_mutator(Node *node, fix_u
*** 2364,2369 ****
--- 2470,2486 ----
  		/* If not supplied by input plan, evaluate the contained expr */
  		return fix_upper_expr_mutator((Node *) phv->phexpr, context);
  	}
+ 	if (get_wholerow_ref_from_convert_row_type(node))
+ 	{
+ 		if (context->subplan_itlist->has_conv_whole_rows)
+ 		{
+ 			newvar = search_indexed_tlist_for_non_var((Expr *) node,
+ 													  context->subplan_itlist,
+ 													  context->newvarno);
+ 			if (newvar)
+ 				return (Node *) newvar;
+ 		}
+ 	}
  	if (IsA(node, Param))
  		return fix_param_node(context->root, (Param *) node);
  	if (IsA(node, Aggref))
*************** fix_upper_expr_mutator(Node *node, fix_u
*** 2389,2395 ****
  		/* If no match, just fall through to process it normally */
  	}
  	/* Try matching more complex expressions too, if tlist has any */
! 	if (context->subplan_itlist->has_non_vars)
  	{
  		newvar = search_indexed_tlist_for_non_var((Expr *) node,
  												  context->subplan_itlist,
--- 2506,2513 ----
  		/* If no match, just fall through to process it normally */
  	}
  	/* Try matching more complex expressions too, if tlist has any */
! 	if (context->subplan_itlist->has_grp_vars ||
! 		context->subplan_itlist->has_non_vars)
  	{
  		newvar = search_indexed_tlist_for_non_var((Expr *) node,
  												  context->subplan_itlist,
*************** extract_query_dependencies_walker(Node *
*** 2596,2598 ****
--- 2714,2748 ----
  	return expression_tree_walker(node, extract_query_dependencies_walker,
  								  (void *) context);
  }
+ 
+ /*
+  * get_wholerow_ref_from_convert_row_type
+  *		Given a node, check if it's a ConvertRowtypeExpr encapsulating a
+  *		whole-row reference as implicit cast and return the whole-row
+  *		reference Var if so. Otherwise return NULL. In case of multi-level
+  *		partitioning, we will have as many nested ConvertRowtypeExpr as there
+  *		are levels in partition hierarchy.
+  */
+ static Var *
+ get_wholerow_ref_from_convert_row_type(Node *node)
+ {
+ 	Var		   *var = NULL;
+ 	ConvertRowtypeExpr *convexpr;
+ 
+ 	if (!node || !IsA(node, ConvertRowtypeExpr))
+ 		return NULL;
+ 
+ 	/* Traverse nested ConvertRowtypeExpr's. */
+ 	convexpr = castNode(ConvertRowtypeExpr, node);
+ 	while (convexpr->convertformat == COERCE_IMPLICIT_CAST &&
+ 		   IsA(convexpr->arg, ConvertRowtypeExpr))
+ 		convexpr = (ConvertRowtypeExpr *) convexpr->arg;
+ 
+ 	if (IsA(convexpr->arg, Var))
+ 		var = castNode(Var, convexpr->arg);
+ 
+ 	if (var && var->varattno == 0)
+ 		return var;
+ 
+ 	return NULL;
+ }
